#include "virtio_fs_regs.h"
#include <linux/virtio_config.h>

void virtio_fs_regs_set(const struct virtio_fs_regs_set_attr *attr,
                        struct snap_virtio_fs_registers *regs)
{
    uint64_t device_features = 0;

    if (!attr->legacy_mode)
        device_features |= 1ULL << VIRTIO_F_VERSION_1;

    regs->queue_size = attr->queue_depth;
    regs->num_request_queues = attr->max_queues - 1;

    regs->device_features = device_features;

    if (attr->tag) {
        // Work-around for compilation error on -Wstringop-truncation
        int len = strlen(attr->tag);
        int copy_len = snap_min(sizeof(regs->tag), len);
        memcpy(regs->tag, attr->tag, copy_len);
    }
}
